groff-commit
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[groff] 24/40: [tests]: Add future regression test.


From: G. Branden Robinson
Subject: [groff] 24/40: [tests]: Add future regression test.
Date: Mon, 12 Dec 2022 19:28:06 -0500 (EST)

gbranden pushed a commit to branch master
in repository groff.

commit d6d60e92c0ac024ce747517e7299986f7b4259b1
Author: G. Branden Robinson <g.branden.robinson@gmail.com>
AuthorDate: Sun Dec 11 13:16:54 2022 -0600

    [tests]: Add future regression test.
    
    [tests]: Add future regression test for header/footer mishandling that
    wasn't already covered (not a live bug; was exposed by attempted
    refactoring).
    
    * tmac/tests/andoc_check-an-to-doc-transition.sh: Do it.
    
    * tmac/tmac.am (tmac_TESTS): Run test.
---
 ChangeLog                                      |  9 ++++
 tmac/tests/andoc_check-an-to-doc-transition.sh | 68 ++++++++++++++++++++++++++
 tmac/tmac.am                                   |  1 +
 3 files changed, 78 insertions(+)

diff --git a/ChangeLog b/ChangeLog
index 1ee978a28..cc20c0e24 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,12 @@
+2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>
+
+       [tests]: Add future regression test for header/footer
+       mishandling that wasn't already covered (not a live bug; was
+       exposed by attempted refactoring).
+
+       * tmac/tests/andoc_check-an-to-doc-transition.sh: Do it.
+       * tmac/tmac.am (tmac_TESTS): Run test.
+
 2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>
 
        [man, mdoc]: Trivially refactor.
diff --git a/tmac/tests/andoc_check-an-to-doc-transition.sh 
b/tmac/tests/andoc_check-an-to-doc-transition.sh
new file mode 100755
index 000000000..42dc2ee3e
--- /dev/null
+++ b/tmac/tests/andoc_check-an-to-doc-transition.sh
@@ -0,0 +1,68 @@
+#!/bin/sh
+#
+# Copyright (C) 2022 Free Software Foundation, Inc.
+#
+# This file is part of groff.
+#
+# groff is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free
+# Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# groff is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+groff="${abs_top_builddir:-.}/test-groff"
+
+fail=
+
+wail () {
+    echo "...FAILED" >&2
+    fail=YES
+}
+
+input='.TH foo 1 2022-12-11 "groff test suite"
+.SH Name
+foo \- frobinicate a bar
+.Dd 2022-12-11
+.Dt bar 1
+.Os "groff test suite"
+.Sh Name
+.Nm bar
+.Nd erect a thing to be walked into'
+
+output=$(printf "%s\n" "$input" | "$groff" -mandoc -Tascii -P-cbou)
+echo "$output"
+
+echo "checking for one foo(1) header" >&2
+test $(echo "$output" \
+         | grep -Ec "foo\(1\) +General Commands Manual +foo\(1\)") \
+    -eq 1 || fail
+
+echo "checking for one foo(1) footer" >&2
+test $(echo "$output" \
+         | grep -Ec "groff test suite +2022-12-11 +foo\(1\)") -eq 1 \
+    || fail
+
+echo "checking for one bar(1) header" >&2
+test $(echo "$output" \
+         | grep -Ec "bar\(1\) +General Commands Manual +bar\(1\)") \
+    -eq 1 || fail
+
+echo "checking for one bar(1) barter" >&2
+test $(echo "$output" \
+         | grep -Ec "groff test suite +2022-12-11 +bar\(1\)") -eq 1 \
+    || fail
+
+echo "checking for uninitialized header and footer fields"
+echo "$output" | grep -E "(UNTITLED|UNDATED|LOCAL)" && fail
+
+test -z "$fail"
+
+# vim:set ai et sw=4 ts=4 tw=72:
diff --git a/tmac/tmac.am b/tmac/tmac.am
index 26f44b7b5..46d81dcbb 100644
--- a/tmac/tmac.am
+++ b/tmac/tmac.am
@@ -186,6 +186,7 @@ tmac_TESTS = \
   tmac/tests/an_title-abbreviation-works.sh \
   tmac/tests/an_use-input-traps-correctly.sh \
   tmac/tests/an_works-with-ec.sh \
+  tmac/tests/andoc_check-an-to-doc-transition.sh \
   tmac/tests/andoc_clear-doc-traps.sh \
   tmac/tests/andoc_flush-between-packages.sh \
   tmac/tests/doc_CS-works.sh \



reply via email to

[Prev in Thread] Current Thread [Next in Thread]